Index: uspace/app/inet/inet.c
===================================================================
--- uspace/app/inet/inet.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/inet/inet.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,5 @@
 #include <inet/addr.h>
 #include <inet/inetcfg.h>
+#include <io/table.h>
 #include <loc.h>
 #include <stdio.h>
@@ -48,9 +49,13 @@
 static void print_syntax(void)
 {
-	printf("syntax:\n");
-	printf("\t" NAME " create <addr>/<width> <link-name> <addr-name>\n");
-	printf("\t" NAME " delete <link-name> <addr-name>\n");
-	printf("\t" NAME " add-sr <dest-addr>/<width> <router-addr> <route-name>\n");
-	printf("\t" NAME " del-sr <route-name>\n");
+	printf("%s: Internet configuration utility.\n", NAME);
+	printf("Syntax:\n");
+	printf("  %s list-addr\n", NAME);
+	printf("  %s create-addr <addr>/<width> <link-name> <addr-name>\n", NAME);
+	printf("  %s delete-addr <link-name> <addr-name>\n", NAME);
+	printf("  %s list-sr\n", NAME);
+	printf("  %s create-sr <dest-addr>/<width> <router-addr> <route-name>\n", NAME);
+	printf("  %s delete-sr <route-name>\n", NAME);
+	printf("  %s list-link\n", NAME);
 }
 
@@ -242,9 +247,13 @@
 	inet_addr_info_t ainfo;
 	inet_link_info_t linfo;
+	table_t *table = NULL;
 
 	size_t count;
 	size_t i;
 	int rc;
-	char *astr;
+	char *astr = NULL;
+
+	ainfo.name = NULL;
+	linfo.name = NULL;
 
 	rc = inetcfg_get_addr_list(&addr_list, &count);
@@ -254,10 +263,13 @@
 	}
 
-	printf("Configured addresses:\n");
-	if (count > 0)
-		printf("    [Addr/Width] [Link-Name] [Addr-Name] [Def-MTU]\n");
-	ainfo.name = NULL;
-	linfo.name = NULL;
-	astr = NULL;
+	rc = table_create(&table);
+	if (rc != EOK) {
+		printf("Memory allocation failed.\n");
+		goto out;
+	}
+
+	table_header_row(table);
+	table_printf(table, "Addr/Width\t" "Link-Name\t" "Addr-Name\t"
+	    "Def-MTU\n");
 
 	for (i = 0; i < count; i++) {
@@ -285,6 +297,6 @@
 		}
 
-		printf("    %s %s %s %zu\n", astr, linfo.name,
-		    ainfo.name, linfo.def_mtu);
+		table_printf(table, "%s\t" "%s\t" "%s\t" "%zu\n", astr,
+		    linfo.name, ainfo.name, linfo.def_mtu);
 
 		free(ainfo.name);
@@ -297,7 +309,15 @@
 	}
 
-	if (count == 0)
-		printf("    None\n");
+	if (count != 0) {
+		rc = table_print_out(table, stdout);
+		if (rc != EOK) {
+			printf("Error printing table.\n");
+			goto out;
+		}
+	}
+
+	rc = EOK;
 out:
+	table_destroy(table);
 	if (ainfo.name != NULL)
 		free(ainfo.name);
@@ -309,11 +329,12 @@
 	free(addr_list);
 
-	return EOK;
+	return rc;
 }
 
 static int link_list(void)
 {
-	sysarg_t *link_list;
+	sysarg_t *link_list = NULL;
 	inet_link_info_t linfo;
+	table_t *table = NULL;
 
 	size_t count;
@@ -327,7 +348,12 @@
 	}
 
-	printf("IP links:\n");
-	if (count > 0)
-		printf("    [Link-layer Address] [Link-Name] [Def-MTU]\n");
+	rc = table_create(&table);
+	if (rc != EOK) {
+		printf("Memory allocation failed.\n");
+		goto out;
+	}
+
+	table_header_row(table);
+	table_printf(table, "Link-layer Address\t" "Link-Name\t" "Def-MTU\n");
 
 	for (i = 0; i < count; i++) {
@@ -339,5 +365,6 @@
 		}
 
-		printf("    %02x:%02x:%02x:%02x:%02x:%02x %s %zu\n",
+		table_printf(table, "%02x:%02x:%02x:%02x:%02x:%02x\t"
+		    "%s\t" "%zu\n",
 		    linfo.mac_addr[0], linfo.mac_addr[1],
 		    linfo.mac_addr[2], linfo.mac_addr[3],
@@ -350,22 +377,33 @@
 	}
 
-	if (count == 0)
-		printf("    None\n");
-
+	if (count != 0) {
+		rc = table_print_out(table, stdout);
+		if (rc != EOK) {
+			printf("Error printing table.\n");
+			goto out;
+		}
+	}
+
+	rc = EOK;
+out:
+	table_destroy(table);
 	free(link_list);
 
-	return EOK;
+	return rc;
 }
 
 static int sroute_list(void)
 {
-	sysarg_t *sroute_list;
+	sysarg_t *sroute_list = NULL;
 	inet_sroute_info_t srinfo;
+	table_t *table = NULL;
 
 	size_t count;
 	size_t i;
 	int rc;
-	char *dest_str;
-	char *router_str;
+	char *dest_str = NULL;
+	char *router_str = NULL;
+
+	srinfo.name = NULL;
 
 	rc = inetcfg_get_sroute_list(&sroute_list, &count);
@@ -375,11 +413,12 @@
 	}
 
-	printf("Static routes:\n");
-	if (count > 0)
-		printf("    [Dest/Width] [Router-Addr] [Route-Name]\n");
-
-	srinfo.name = NULL;
-	dest_str = NULL;
-	router_str = NULL;
+	rc = table_create(&table);
+	if (rc != EOK) {
+		printf("Memory allocation failed.\n");
+		goto out;
+	}
+
+	table_header_row(table);
+	table_printf(table, "Dest/Width\t" "Router-Addr\t" "Route-Name\n");
 
 	for (i = 0; i < count; i++) {
@@ -406,5 +445,6 @@
 		}
 
-		printf("    %s %s %s\n", dest_str, router_str, srinfo.name);
+		table_printf(table, "%s\t" "%s\t" "%s\n", dest_str, router_str,
+		    srinfo.name);
 
 		free(srinfo.name);
@@ -417,7 +457,15 @@
 	}
 
-	if (count == 0)
-		printf("    None\n");
+	if (count != 0) {
+		rc = table_print_out(table, stdout);
+		if (rc != EOK) {
+			printf("Error printing table.\n");
+			goto out;
+		}
+	}
+
+	rc = EOK;
 out:
+	table_destroy(table);
 	if (srinfo.name != NULL)
 		free(srinfo.name);
@@ -429,5 +477,5 @@
 	free(sroute_list);
 
-	return EOK;
+	return rc;
 }
 
@@ -443,31 +491,35 @@
 	}
 
-	if (argc < 2) {
+	if (argc < 2 || str_cmp(argv[1], "-h") == 0) {
+		print_syntax();
+		return 0;
+	}
+
+	if (str_cmp(argv[1], "list-addr") == 0) {
 		rc = addr_list();
 		if (rc != EOK)
 			return 1;
+	} else if (str_cmp(argv[1], "create-addr") == 0) {
+		rc = addr_create_static(argc - 2, argv + 2);
+		if (rc != EOK)
+			return 1;
+	} else if (str_cmp(argv[1], "delete-addr") == 0) {
+		rc = addr_delete(argc - 2, argv + 2);
+		if (rc != EOK)
+			return 1;
+	} else if (str_cmp(argv[1], "list-sr") == 0) {
 		rc = sroute_list();
 		if (rc != EOK)
 			return 1;
+	} else if (str_cmp(argv[1], "create-sr") == 0) {
+		rc = sroute_create(argc - 2, argv + 2);
+		if (rc != EOK)
+			return 1;
+	} else if (str_cmp(argv[1], "delete-sr") == 0) {
+		rc = sroute_delete(argc - 2, argv + 2);
+		if (rc != EOK)
+			return 1;
+	} else if (str_cmp(argv[1], "list-link") == 0) {
 		rc = link_list();
-		if (rc != EOK)
-			return 1;
-		return 0;
-	}
-
-	if (str_cmp(argv[1], "create") == 0) {
-		rc = addr_create_static(argc - 2, argv + 2);
-		if (rc != EOK)
-			return 1;
-	} else if (str_cmp(argv[1], "delete") == 0) {
-		rc = addr_delete(argc - 2, argv + 2);
-		if (rc != EOK)
-			return 1;
-	} else if (str_cmp(argv[1], "add-sr") == 0) {
-		rc = sroute_create(argc - 2, argv + 2);
-		if (rc != EOK)
-			return 1;
-	} else if (str_cmp(argv[1], "del-sr") == 0) {
-		rc = sroute_delete(argc - 2, argv + 2);
 		if (rc != EOK)
 			return 1;
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/init/init.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -340,7 +340,5 @@
 	srv_start("/srv/apic");
 	srv_start("/srv/i8259");
-	srv_start("/srv/icp-ic");
 	srv_start("/srv/obio");
-	srv_start("/srv/cuda_adb");
 	srv_start("/srv/s3c24xx_uart");
 	srv_start("/srv/s3c24xx_ts");
Index: uspace/app/loc/loc.c
===================================================================
--- uspace/app/loc/loc.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/loc/loc.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,6 +38,6 @@
 #include <stdlib.h>
 #include <stdint.h>
+#include <inttypes.h>
 #include <str.h>
-#include <sys/typefmt.h>
 
 #define NAME "loc"
Index: uspace/app/mkexfat/exfat.h
===================================================================
--- uspace/app/mkexfat/exfat.h	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/mkexfat/exfat.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -37,4 +37,5 @@
 #define EXFAT_FILENAME_LEN	255
 #define EXFAT_NAME_PART_LEN	15
+#define EXFAT_VOLLABEL_LEN	11
 
 #define EXFAT_TYPE_UNUSED	0x00
Index: uspace/app/mkexfat/mkexfat.c
===================================================================
--- uspace/app/mkexfat/mkexfat.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/mkexfat/mkexfat.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -46,5 +46,4 @@
 #include <byteorder.h>
 #include <align.h>
-#include <sys/typefmt.h>
 #include <str.h>
 #include <getopt.h>
@@ -102,6 +101,6 @@
 	size_t   sector_size;
 	size_t   cluster_size;
+	const char *label;
 } exfat_cfg_t;
-
 
 static unsigned log2(unsigned n);
@@ -127,4 +126,5 @@
 	{"cluster-size", required_argument, 0, 'c'},
 	{"fs-size", required_argument, 0, 's'},
+	{"label", required_argument, 0, 'L' },
 };
 
@@ -133,5 +133,6 @@
 	printf("Usage: mkexfat [options] <device>\n"
 	    "-c, --cluster-size ## Specify the cluster size (Kb)\n"
-	    "-s, --fs-size ##      Specify the filesystem size (sectors)\n");
+	    "-s, --fs-size ##      Specify the filesystem size (sectors)\n"
+	    "    --label ##        Volume label\n");
 }
 
@@ -598,4 +599,5 @@
 	exfat_dentry_t *d;
 	aoff64_t rootdir_sec;
+	uint16_t wlabel[EXFAT_VOLLABEL_LEN + 1];
 	int rc;
 	uint8_t *data;
@@ -609,9 +611,22 @@
 
 	/* Initialize the volume label dentry */
-	d->type = EXFAT_TYPE_VOLLABEL;
-	str_to_utf16(d->vollabel.label, 8, "HELENOS ");
-	d->vollabel.size = 8;
-
-	d++;
+
+	if (cfg->label != NULL) {
+		memset(wlabel, 0, (EXFAT_VOLLABEL_LEN + 1) * sizeof(uint16_t));
+		rc = str_to_utf16(wlabel, EXFAT_VOLLABEL_LEN + 1, cfg->label);
+		if (rc != EOK) {
+			rc = EINVAL;
+			goto exit;
+		}
+
+		d->type = EXFAT_TYPE_VOLLABEL;
+		memcpy(d->vollabel.label, wlabel, EXFAT_VOLLABEL_LEN * 2);
+		d->vollabel.size = utf16_wsize(wlabel);
+		assert(d->vollabel.size <= EXFAT_VOLLABEL_LEN);
+
+		d++;
+	} else {
+		d->type = EXFAT_TYPE_VOLLABEL & ~EXFAT_TYPE_USED;
+	}
 
 	/* Initialize the allocation bitmap dentry */
@@ -752,7 +767,8 @@
 
 	cfg.cluster_size = 0;
+	cfg.label = NULL;
 
 	for (c = 0, optind = 0, opt_ind = 0; c != -1;) {
-		c = getopt_long(argc, argv, "hs:c:",
+		c = getopt_long(argc, argv, "hs:c:L:",
 		    long_options, &opt_ind);
 		switch (c) {
@@ -782,4 +798,7 @@
 			}
 			break;
+		case 'L':
+			cfg.label = optarg;
+			break;
 		}
 	}
Index: uspace/app/mkfat/fat_dentry.h
===================================================================
--- uspace/app/mkfat/fat_dentry.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/app/mkfat/fat_dentry.h	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,143 @@
+/*
+ * Copyright (c) 2008 Jakub Jermar
+ * Copyright (c) 2011 Oleg Romanenko
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup fs
+ * @{
+ */ 
+
+#ifndef FAT_FAT_DENTRY_H_
+#define FAT_FAT_DENTRY_H_
+
+#include <stdint.h>
+#include <stdbool.h>
+#include <stddef.h>
+#include <unaligned.h>
+
+#define IS_D_CHAR(ch) (isalnum(ch) || ch == '_')
+#define FAT_STOP_CHARS "*?/\\\n\t|'"
+
+#define FAT_NAME_LEN		8
+#define FAT_EXT_LEN		3
+#define FAT_VOLLABEL_LEN	11
+
+#define FAT_NAME_DOT		".       "
+#define FAT_NAME_DOT_DOT	"..      "
+#define FAT_EXT_PAD		"   "
+
+#define FAT_ATTR_RDONLY   0x01
+#define FAT_ATTR_HIDDEN   0x02
+#define FAT_ATTR_SYSTEM   0x04
+#define FAT_ATTR_VOLLABEL 0x08
+#define FAT_ATTR_SUBDIR   0x10
+#define FAT_ATTR_ARCHIVE  0x20
+#define FAT_ATTR_LFN \
+    (FAT_ATTR_RDONLY | FAT_ATTR_HIDDEN | FAT_ATTR_SYSTEM | FAT_ATTR_VOLLABEL)
+    
+#define FAT_LCASE_LOWER_NAME	0x08
+#define FAT_LCASE_LOWER_EXT	0x10
+
+#define FAT_PAD			' '
+#define FAT_LFN_PAD	0xffff
+#define FAT_SFN_CHAR '_'
+
+#define FAT_DENTRY_UNUSED	0x00
+#define FAT_DENTRY_E5_ESC	0x05
+#define FAT_DENTRY_DOT		0x2e
+#define FAT_DENTRY_ERASED	0xe5
+#define FAT_LFN_LAST		0x40
+#define FAT_LFN_ERASED		0x80
+
+#define FAT_LFN_ORDER(d) ((d)->lfn.order)
+#define FAT_IS_LFN(d) \
+    ((FAT_LFN_ORDER((d)) & FAT_LFN_LAST) == FAT_LFN_LAST)
+#define FAT_LFN_COUNT(d) \
+    (FAT_LFN_ORDER((d)) ^ FAT_LFN_LAST)
+#define FAT_LFN_PART1(d) ((d)->lfn.part1)
+#define FAT_LFN_PART2(d) ((d)->lfn.part2)
+#define FAT_LFN_PART3(d) ((d)->lfn.part3)
+#define FAT_LFN_ATTR(d) ((d)->lfn.attr)
+#define FAT_LFN_CHKSUM(d) ((d)->lfn.check_sum)
+
+#define FAT_LFN_NAME_LEN    260                           /* characters */
+#define FAT_LFN_NAME_SIZE   STR_BOUNDS(FAT_LFN_NAME_LEN)  /* bytes */
+#define FAT_LFN_MAX_COUNT   20
+#define FAT_LFN_PART1_SIZE  5
+#define FAT_LFN_PART2_SIZE  6
+#define FAT_LFN_PART3_SIZE  2
+#define FAT_LFN_ENTRY_SIZE \
+    (FAT_LFN_PART1_SIZE + FAT_LFN_PART2_SIZE + FAT_LFN_PART3_SIZE)
+
+typedef enum {
+	FAT_DENTRY_SKIP,
+	FAT_DENTRY_LAST,
+	FAT_DENTRY_FREE,
+	FAT_DENTRY_VALID,
+	FAT_DENTRY_LFN,
+	FAT_DENTRY_VOLLABEL
+} fat_dentry_clsf_t;
+
+typedef union {
+	struct {
+		uint8_t		name[8];
+		uint8_t		ext[3];
+		uint8_t		attr;
+		uint8_t		lcase;
+		uint8_t		ctime_fine;
+		uint16_t	ctime;
+		uint16_t	cdate;
+		uint16_t	adate;
+		union {
+			uint16_t	eaidx;		/* FAT12/FAT16 */
+			uint16_t	firstc_hi;	/* FAT32 */
+		} __attribute__ ((packed));
+		uint16_t	mtime;
+		uint16_t	mdate;
+		union {
+			uint16_t	firstc;		/* FAT12/FAT16 */
+			uint16_t	firstc_lo;	/* FAT32 */
+		} __attribute__ ((packed));
+		uint32_t	size;
+	} __attribute__ ((packed));
+	struct {
+		uint8_t		order;
+		uint16_t	part1[FAT_LFN_PART1_SIZE];
+		uint8_t		attr;
+		uint8_t		type;
+		uint8_t		check_sum;
+		uint16_t	part2[FAT_LFN_PART2_SIZE];
+		uint16_t	firstc_lo; /* MUST be 0 */
+		uint16_t	part3[FAT_LFN_PART3_SIZE];
+	} __attribute__ ((packed)) lfn;
+} __attribute__ ((packed)) fat_dentry_t;
+
+#endif
+
+/**
+ * @}
+ */
Index: uspace/app/mkfat/mkfat.c
===================================================================
--- uspace/app/mkfat/mkfat.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/mkfat/mkfat.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -38,4 +38,5 @@
  */
 
+#include <ctype.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -45,10 +46,12 @@
 #include <loc.h>
 #include <byteorder.h>
-#include <sys/typefmt.h>
 #include <inttypes.h>
 #include <errno.h>
 #include "fat.h"
+#include "fat_dentry.h"
 
 #define NAME	"mkfat"
+
+#define LABEL_NONAME "NO NAME"
 
 /** Divide and round up. */
@@ -78,4 +81,5 @@
 	uint32_t total_clusters;
 	uint8_t fat_count;
+	const char *label;
 } fat_cfg_t;
 
@@ -103,4 +107,5 @@
 	cfg.root_ent_max = 128;
 	cfg.fat_type = FATAUTO;
+	cfg.label = NULL;
 
 	if (argc < 2) {
@@ -111,38 +116,59 @@
 
 	--argc; ++argv;
-	if (str_cmp(*argv, "--size") == 0) {
-		--argc; ++argv;
-		if (*argv == NULL) {
-			printf(NAME ": Error, argument missing.\n");
-			syntax_print();
-			return 1;
+
+	while (*argv[0] == '-') {
+		if (str_cmp(*argv, "--size") == 0) {
+			--argc; ++argv;
+			if (*argv == NULL) {
+				printf(NAME ": Error, argument missing.\n");
+				syntax_print();
+				return 1;
+			}
+
+			cfg.total_sectors = strtol(*argv, &endptr, 10);
+			if (*endptr != '\0') {
+				printf(NAME ": Error, invalid argument.\n");
+				syntax_print();
+				return 1;
+			}
+
+			--argc; ++argv;
 		}
 
-		cfg.total_sectors = strtol(*argv, &endptr, 10);
-		if (*endptr != '\0') {
-			printf(NAME ": Error, invalid argument.\n");
-			syntax_print();
-			return 1;
+		if (str_cmp(*argv, "--type") == 0) {
+			--argc; ++argv;
+			if (*argv == NULL) {
+				printf(NAME ": Error, argument missing.\n");
+				syntax_print();
+				return 1;
+			}
+
+			cfg.fat_type = strtol(*argv, &endptr, 10);
+			if (*endptr != '\0') {
+				printf(NAME ": Error, invalid argument.\n");
+				syntax_print();
+				return 1;
+			}
+
+			--argc; ++argv;
 		}
 
-		--argc; ++argv;
-	}
-
-	if (str_cmp(*argv, "--type") == 0) {
-		--argc; ++argv;
-		if (*argv == NULL) {
-			printf(NAME ": Error, argument missing.\n");
-			syntax_print();
-			return 1;
+		if (str_cmp(*argv, "--label") == 0) {
+			--argc; ++argv;
+			if (*argv == NULL) {
+				printf(NAME ": Error, argument missing.\n");
+				syntax_print();
+				return 1;
+			}
+
+			cfg.label = *argv;
+
+			--argc; ++argv;
 		}
 
-		cfg.fat_type = strtol(*argv, &endptr, 10);
-		if (*endptr != '\0') {
-			printf(NAME ": Error, invalid argument.\n");
-			syntax_print();
-			return 1;
+		if (str_cmp(*argv, "-") == 0) {
+			--argc; ++argv;
+			break;
 		}
-
-		--argc; ++argv;
 	}
 
@@ -195,5 +221,5 @@
 	}
 
-	printf(NAME ": Creating FAT%d filesystem on device %s.\n", cfg.fat_type, dev_path);
+	printf(NAME ": Creating FAT filesystem on device %s.\n", dev_path);
 
 	rc = fat_params_compute(&cfg);
@@ -203,4 +229,6 @@
 	}
 
+	printf(NAME ": Filesystem type FAT%d.\n", cfg.fat_type);
+
 	rc = fat_blocks_write(&cfg, service_id);
 	if (rc != EOK) {
@@ -217,5 +245,36 @@
 static void syntax_print(void)
 {
-	printf("syntax: mkfat [--size <sectors>] [--type 12|16|32] <device_name>\n");
+	printf("syntax: mkfat [<options>...] <device_name>\n");
+	printf("options:\n"
+	    "\t--size <sectors> Filesystem size, overrides device size\n"
+	    "\t--type 12|16|32  FAT type (auto-detected by default)\n"
+	    "\t--label <label>  Volume label\n");
+}
+
+static int fat_label_encode(void *dest, const char *src)
+{
+	int i;
+	const char *sp;
+	uint8_t *dp;
+
+	i = 0;
+	sp = src;
+	dp = (uint8_t *)dest;
+
+	while (*sp != '\0' && i < FAT_VOLLABEL_LEN) {
+		if (!ascii_check(*sp))
+			return EINVAL;
+		if (dp != NULL)
+			dp[i] = toupper(*sp);
+		++i; ++sp;
+	}
+
+	while (i < FAT_VOLLABEL_LEN) {
+		if (dp != NULL)
+			dp[i] = FAT_PAD;
+		++i;
+	}
+
+	return EOK;
 }
 
@@ -228,5 +287,8 @@
 {
 	uint32_t fat_bytes;
+	uint32_t non_data_sectors_lb_16;
 	uint32_t non_data_sectors_lb;
+	uint32_t rd_sectors;
+	uint32_t tot_clust_16;
 
 	/*
@@ -234,24 +296,26 @@
 	 * system. The optimum could be potentially smaller since we
 	 * do not subtract size of the FAT itself when computing the
-	 * size of the data region.
+	 * size of the data region. Also the root dir area might not
+	 * need FAT entries if we decide to make a FAT32.
 	 */
 
 	cfg->reserved_sectors = 1 + cfg->addt_res_sectors;
-	if (cfg->fat_type != FAT32) {
-		cfg->rootdir_sectors = div_round_up(cfg->root_ent_max * DIRENT_SIZE,
-			cfg->sector_size);
-	} else
-		cfg->rootdir_sectors = 0;
-	non_data_sectors_lb = cfg->reserved_sectors + cfg->rootdir_sectors;
-
-	cfg->total_clusters = div_round_up(cfg->total_sectors - non_data_sectors_lb,
+
+	/* Only correct for FAT12/16 (FAT32 has root dir stored in clusters */
+	rd_sectors = div_round_up(cfg->root_ent_max * DIRENT_SIZE,
+		cfg->sector_size);
+	non_data_sectors_lb_16 = cfg->reserved_sectors + rd_sectors;
+
+	/* Only correct for FAT12/16 */
+	tot_clust_16 = div_round_up(cfg->total_sectors - non_data_sectors_lb_16,
 	    cfg->sectors_per_cluster);
 
-	if (cfg->total_clusters <= FAT12_CLST_MAX) {
+	/* Now detect FAT type */
+	if (tot_clust_16 <= FAT12_CLST_MAX) {
 		if (cfg->fat_type == FATAUTO)
 			cfg->fat_type = FAT12;
 		else if (cfg->fat_type != FAT12)
 			return EINVAL;
-	} else if (cfg->total_clusters <= FAT16_CLST_MAX) {
+	} else if (tot_clust_16 <= FAT16_CLST_MAX) {
 		if (cfg->fat_type == FATAUTO)
 			cfg->fat_type = FAT16;
@@ -265,7 +329,26 @@
 	}
 
+	/* Actual root directory size, non-data sectors */
+	if (cfg->fat_type != FAT32) {
+		cfg->rootdir_sectors = div_round_up(cfg->root_ent_max * DIRENT_SIZE,
+			cfg->sector_size);
+		non_data_sectors_lb = cfg->reserved_sectors + cfg->rootdir_sectors;
+
+	} else {
+		/* We create a single-cluster root dir */
+		cfg->rootdir_sectors = cfg->sectors_per_cluster;
+		non_data_sectors_lb = cfg->reserved_sectors;
+	}
+
+	/* Actual total number of clusters */
+	cfg->total_clusters = div_round_up(cfg->total_sectors - non_data_sectors_lb,
+	    cfg->sectors_per_cluster);
+
 	fat_bytes = div_round_up((cfg->total_clusters + 2) *
 	    FAT_CLUSTER_DOUBLE_SIZE(cfg->fat_type), 2);
 	cfg->fat_sectors = div_round_up(fat_bytes, cfg->sector_size);
+
+	if (cfg->label != NULL && fat_label_encode(NULL, cfg->label) != EOK)
+		return EINVAL;
 
 	return EOK;
@@ -281,4 +364,5 @@
 	int rc;
 	struct fat_bs bs;
+	fat_dentry_t *de;
 
 	fat_bootsec_create(cfg, &bs);
@@ -340,21 +424,24 @@
 	printf("Writing root directory.\n");
 	memset(buffer, 0, cfg->sector_size);
-	if (cfg->fat_type != FAT32) {
-		size_t idx;
-		for (idx = 0; idx < cfg->rootdir_sectors; ++idx) {
-			rc = block_write_direct(service_id, addr, 1, buffer);
-			if (rc != EOK)
-				return EIO;
-
-			++addr;
+	de = (fat_dentry_t *)buffer;
+	size_t idx;
+	for (idx = 0; idx < cfg->rootdir_sectors; ++idx) {
+
+		if (idx == 0 && cfg->label != NULL) {
+			/* Set up volume label entry */
+			(void) fat_label_encode(&de->name, cfg->label);
+			de->attr = FAT_ATTR_VOLLABEL;
+			de->mtime = 0x1234;
+			de->mdate = 0x1234;
+		} else if (idx == 1) {
+			/* Clear volume label entry */
+			memset(buffer, 0, cfg->sector_size);
 		}
-	} else {
-		for (i = 0; i < cfg->sectors_per_cluster; i++) {
-			rc = block_write_direct(service_id, addr, 1, buffer);
-			if (rc != EOK)
-				return EIO;
-
-			++addr;
-		}	
+
+		rc = block_write_direct(service_id, addr, 1, buffer);
+		if (rc != EOK)
+			return EIO;
+
+		++addr;
 	}
 
@@ -367,4 +454,14 @@
 static void fat_bootsec_create(struct fat_cfg const *cfg, struct fat_bs *bs)
 {
+	const char *bs_label;
+
+	/*
+	 * The boot sector must always contain a valid label. If there
+	 * is no label, there should be 'NO NAME'
+	 */
+	if (cfg->label != NULL)
+		bs_label = cfg->label;
+	else
+		bs_label = LABEL_NONAME;
 	memset(bs, 0, sizeof(*bs));
 
@@ -405,5 +502,5 @@
 		bs->fat32.root_cluster = 2;
 
-		memcpy(bs->fat32.label, "HELENOS_NEW", 11);
+		(void) fat_label_encode(&bs->fat32.label, bs_label);
 		memcpy(bs->fat32.type, "FAT32   ", 8);
 	} else {
@@ -413,6 +510,9 @@
 		bs->id = host2uint32_t_be(0x12345678);
 
-		memcpy(bs->label, "HELENOS_NEW", 11);
-		memcpy(bs->type, "FAT   ", 8);
+		(void) fat_label_encode(&bs->label, bs_label);
+		if (cfg->fat_type == FAT12)
+			memcpy(bs->type, "FAT12   ", 8);
+		else
+			memcpy(bs->type, "FAT16   ", 8);
 	}
 }
Index: uspace/app/mkmfs/mkmfs.c
===================================================================
--- uspace/app/mkmfs/mkmfs.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/mkmfs/mkmfs.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -41,5 +41,4 @@
 #include <block.h>
 #include <errno.h>
-#include <sys/typefmt.h>
 #include <inttypes.h>
 #include <getopt.h>
Index: uspace/app/nic/nic.c
===================================================================
--- uspace/app/nic/nic.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/nic/nic.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -120,4 +120,5 @@
 	if (sess == NULL) {
 		printf("Error connecting to service.\n");
+		rc = EIO;
 		goto error;
 	}
@@ -209,5 +210,5 @@
 }
 
-static const char *nic_multicast_mode_str(nic_unicast_mode_t mode)
+static const char *nic_multicast_mode_str(nic_multicast_mode_t mode)
 {
 	switch (mode) {
@@ -220,5 +221,5 @@
 }
 
-static const char *nic_broadcast_mode_str(nic_unicast_mode_t mode)
+static const char *nic_broadcast_mode_str(nic_broadcast_mode_t mode)
 {
 	switch (mode) {
Index: uspace/app/pkg/Makefile
===================================================================
--- uspace/app/pkg/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/app/pkg/Makefile	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,35 @@
+#
+# Copyright (c) 2017 Jiri Svoboda
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+USPACE_PREFIX = ../..
+BINARY = pkg
+
+SOURCES = \
+	pkg.c
+
+include $(USPACE_PREFIX)/Makefile.common
Index: uspace/app/pkg/pkg.c
===================================================================
--- uspace/app/pkg/pkg.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
+++ uspace/app/pkg/pkg.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -0,0 +1,207 @@
+/*
+ * Copyright (c) 2017 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup pkg
+ * @{
+ */
+/** @file Package installer
+ *
+ * Utility to simplify installation of coastline packages
+ */
+
+#include <errno.h>
+#include <macros.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <str_error.h>
+#include <task.h>
+
+#define NAME "pkg"
+
+static void print_syntax(void)
+{
+	fprintf(stderr, "syntax: " NAME " install <package-name>\n");
+}
+
+static int cmd_runl(const char *path, ...)
+{
+	va_list ap;
+	const char *arg;
+	int cnt = 0;
+
+	va_start(ap, path);
+	do {
+		arg = va_arg(ap, const char *);
+		cnt++;
+	} while (arg != NULL);
+	va_end(ap);
+
+	va_start(ap, path);
+	task_id_t id;
+	task_wait_t wait;
+	int rc = task_spawn(&id, &wait, path, cnt, ap);
+	va_end(ap);
+
+	if (rc != EOK) {
+		printf("Error spawning %s (%s)\n", path, str_error(rc));
+		return rc;
+	}
+
+	if (!id) {
+		printf("Error spawning %s (invalid task ID)\n", path);
+		return EINVAL;
+	}
+
+	task_exit_t texit;
+	int retval;
+	rc = task_wait(&wait, &texit, &retval);
+	if (rc != EOK) {
+		printf("Error waiting for %s (%s)\n", path, str_error(rc));
+		return rc;
+	}
+
+	if (texit != TASK_EXIT_NORMAL) {
+		printf("Command %s unexpectedly terminated\n", path);
+		return EINVAL;
+	}
+
+	if (retval != 0) {
+		printf("Command %s returned non-zero exit code %d)\n",
+		    path, retval);
+	}
+
+	return retval;
+}
+
+
+static int pkg_install(int argc, char *argv[])
+{
+	char *pkg_name;
+	char *src_uri;
+	char *fname;
+	char *fnunpack;
+	int rc;
+
+	if (argc != 3) {
+		print_syntax();
+		return EINVAL;
+	}
+
+	pkg_name = argv[2];
+
+	rc = asprintf(&src_uri, "http://ci.helenos.org/latest/" STRING(UARCH)
+	    "/%s-for-helenos-" STRING(UARCH) ".tar.gz",
+	    pkg_name);
+	if (rc < 0) {
+		printf("Out of memory.\n");
+		return ENOMEM;
+	}
+
+	rc = asprintf(&fname, "/tmp/%s-for-helenos-" STRING(UARCH)
+	    ".tar.gz", pkg_name);
+	if (rc < 0) {
+		printf("Out of memory.\n");
+		return ENOMEM;
+	}
+
+	rc = asprintf(&fnunpack, "/tmp/%s-for-helenos-" STRING(UARCH) ".tar",
+	    pkg_name);
+	if (rc < 0) {
+		printf("Out of memory.\n");
+		return ENOMEM;
+	}
+	/*XXX error cleanup */
+
+	printf("Downloading '%s'.\n", src_uri);
+
+	rc = cmd_runl("/app/download", "/app/download", "-o", fname,
+	    src_uri, NULL);
+	if (rc != EOK) {
+		printf("Error downloading package archive.\n");
+		return rc;
+	}
+
+	printf("Extracting package\n");
+
+	rc = cmd_runl("/app/gunzip", "/app/gunzip", fname, fnunpack, NULL);
+	if (rc != EOK) {
+		printf("Error uncompressing package archive.\n");
+		return rc;
+	}
+
+	if (remove(fname) != 0) {
+		printf("Error deleting package archive.\n");
+		return rc;
+	}
+
+
+	rc = cmd_runl("/app/untar", "/app/untar", fnunpack, NULL);
+	if (rc != EOK) {
+		printf("Error extracting package archive.\n");
+		return rc;
+	}
+
+	if (remove(fnunpack) != 0) {
+		printf("Error deleting package archive.\n");
+		return rc;
+	}
+
+	printf("Package '%s' installed.\n", pkg_name);
+
+	return EOK;
+}
+
+int main(int argc, char *argv[])
+{
+	char *cmd;
+	int rc;
+
+	if (argc < 2) {
+		fprintf(stderr, "Arguments missing.\n");
+		print_syntax();
+		return 1;
+	}
+
+	cmd = argv[1];
+
+	if (str_cmp(cmd, "install") == 0) {
+		rc = pkg_install(argc, argv);
+	} else {
+		fprintf(stderr, "Unknown command.\n");
+		print_syntax();
+		return 1;
+	}
+
+	if (rc != EOK)
+		return 1;
+
+	return 0;
+}
+
+/** @}
+ */
Index: uspace/app/sbi/src/builtin/bi_task.c
===================================================================
--- uspace/app/sbi/src/builtin/bi_task.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/sbi/src/builtin/bi_task.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -114,5 +114,5 @@
 	}
 
-	cmd[dim] = '\0';
+	cmd[dim] = NULL;
 
 	if (os_exec((char * const *)cmd) != EOK) {
Index: uspace/app/sbi/src/os/posix.c
===================================================================
--- uspace/app/sbi/src/os/posix.c	(revision dbf32b10e7146a1f953c4eda94c63b8ac246f0ba)
+++ uspace/app/sbi/src/os/posix.c	(revision 95c675b4aa3fea7b424b73892a90b052c673cfd3)
@@ -34,5 +34,5 @@
 #include <stdlib.h>
 #include <string.h>
-#include <sys/types.h>
+#include <types/common.h>
 #include <sys/wait.h>
 #include <unistd.h>
